/**********
 Basic iterator operator interface
 
 Simple query execution engine
 For CSE 544 Homework 2
 **********/
 
import java.util.Vector;

/** Basic interface for iterator-based operators
 */
public interface Operator {
    /** Open the operator within an execution context */
    public boolean open();
    /** Read next tuple from operator */
    public Tuple next();
    /** Close the operator */
    public boolean close();
    /** Check if the operator is open */
    public boolean isOpen();
    
    /** Returns the metadata (labels) */
    public Vector labels();
}